﻿using System;
using System.Web.Mvc;
using System.Web.Routing;
using Isis.Handlers;

namespace Sample.Web
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    public class MvcApplication : System.Web.HttpApplication
    {
        public static void RegisterRoutes(RouteCollection routes)
        {
            var isisHandler = new IsisRoutingHandler();
            routes.Add(new Route("isis", isisHandler));
            routes.Add(new Route("isis/{controller}", isisHandler));
            routes.Add(new Route("isis/{controller}/{action}", isisHandler));
            routes.Add(new Route("isis/{controller}/{action}/{parameter}", isisHandler));

            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute(
                "Default",                                              // Route name
                "{controller}/{action}/{id}",                           // URL with parameters
                new { controller = "Home", action = "Index", id = "" }  // Parameter defaults
            );

        }

        protected void Application_Start()
        {
            RegisterRoutes(RouteTable.Routes);
            AddApplicationValuesForTestingPurposes();
        }

        private void AddApplicationValuesForTestingPurposes()
        {
            Application["StartTime (DateTime)"] = DateTime.Now;
            Application["Name (String)"] = "Isis Sample";
            Application["Meaning Of Life, The Universe, and Everything (int)"] = 42;
            Application["Complex Data Type (Routes)"] = RouteTable.Routes;

        }

    }
}