﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Web.Routing;
using Isis.Interfaces;
using Isis.Model;
using System.Web.Mvc;

namespace Isis.Controllers
{
    public abstract class ControllerBase : IControlPanelController, IController
    {
        public abstract void Render(TextWriter writer);

        public abstract ControllerTab Tab { get; }

        public virtual string Action { get; set; }

        public virtual string Parameter { get; set; }

        public virtual IEnumerable<string> SubTabs
        {
            get { return new string[0]; }
        }

        public virtual void Execute(RequestContext requestContext)
        {
            throw new NotImplementedException();
        }
    }
}