using System.Collections.Generic;
using System.Linq;
using Isis.Controllers;
using NUnit.Framework;
namespace Isis.Tests
{
    [TestFixture]
    public class ControllerRepositoryTester
    {
        [Test]
        public void CanGetNameFromControllerType()
        {
            var controllerRepository = new ControllerRepository();

            string name = controllerRepository.GetControllerNameFromType(typeof(CacheController));

            Assert.AreEqual("Cache", name);
        }        
        
        [Test]
        public void GetControllerTabNamesReturnsTabsOrderedByDisplayPriorityProperty()
        {
            var controllerRepository = new ControllerRepository();

            IEnumerable<string> names = controllerRepository.GetControllerTabNames();

            Assert.AreEqual("Home", names.First());
        }
    }
}