﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NUnit.Framework;
using Isis.Views;

namespace Isis.Tests
{

    [TestFixture]
    public class SubTabWriterGetSubTabUrlFragmentShould
    {
        [Test]
        public void ReturnSameUrlFragmentGivenEmptyString()
        {
            var subTabWriter = new SubTabWriter();
            string result = subTabWriter.GetSubTabUrlFragment(String.Empty);

            Assert.AreEqual(String.Empty, result);
        }

        [Test]
        public void ReturnReplaceSpacesWithUnderscores()
        {
            var subTabWriter = new SubTabWriter();
            string result = subTabWriter.GetSubTabUrlFragment("hello world");

            Assert.AreEqual("hello_world", result);
        }

        [Test]
        public void ReturnReplaceUpperCaseWithLowerCase()
        {
            var subTabWriter = new SubTabWriter();
            string result = subTabWriter.GetSubTabUrlFragment("HelloWorld");

            Assert.AreEqual("helloworld", result);
        }
    }
}
